// AnsiMarlett.cpp by katahiromz
// This file is public domain software (PDS).
#include <windows.h>
#include <windowsx.h>
#include <dlgs.h>

HINSTANCE g_hInstance;

BOOL OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    CheckRadioButton(hwnd, rad1, rad2, rad2);
    return TRUE;
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case rad1:
    case rad2:
        InvalidateRect(hwnd, NULL, TRUE);
        break;
    case IDOK:
        EndDialog(hwnd, IDOK);
        break;
    case IDCANCEL:
        EndDialog(hwnd, IDCANCEL);
        break;
    }
}

void OnPaint(HWND hwnd)
{
    PAINTSTRUCT ps;
    HDC hDC;
    LOGFONT lf;
    HFONT hFont;

    ZeroMemory(&lf, sizeof(lf));
    lstrcpy(lf.lfFaceName, TEXT("Marlett"));
    BOOL bAnsi= (IsDlgButtonChecked(hwnd, rad1) == BST_CHECKED);
    if (bAnsi)
    {
        lf.lfCharSet = ANSI_CHARSET;
    }
    else
    {
        lf.lfCharSet = DEFAULT_CHARSET;
    }
    hFont = CreateFontIndirect(&lf);

    hDC = BeginPaint(hwnd, &ps);
    if (hDC)
    {
        HGDIOBJ hFontOld = SelectObject(hDC, hFont);
        TextOut(hDC, 50, 50, TEXT("r"), 1);
        SelectObject(hDC, hFontOld);
        EndPaint(hwnd, &ps);
    }

    DeleteObject(hFont);
}

extern "C"
INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_INITDIALOG, OnInitDialog);
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
        HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    }
    return 0;
}

extern "C"
INT WINAPI
WinMain(
    HINSTANCE   hInstance,
    HINSTANCE   hPrevInstance,
    LPSTR       lpCmdLine,
    INT         nCmdShow)
{
    g_hInstance = hInstance;
    DialogBox(hInstance, MAKEINTRESOURCE(1), NULL, DialogProc);
    return 0;
}
